# Lösung: Mixin benutzen


```ruby
class Squares
  include Enumerable

  def initialize(max)
    @max = max
  end

  def each
    for i in 1..@max
      yield i ** 2
    end
  end
end

s = Squares.new(20)
s.each { |e| puts e }
s.first
```